Subject: Re: [PATCH 1/2] d80211: Add software RTS support

From: Ivo van Doorn <[email-masked]>
Date: Mon, 5 Feb 2007 19:15:52 +0100

On Monday 05 February 2007 19:08, Jiri Benc wrote:
> On Mon, 5 Feb 2007 18:43:06 +0100, Michael Buesch wrote:
> > I also think that sending RTS in software is not going to work,
> > as the timing can not be guaranteed. And timing is why we do it in
> > the first place. If the HW is not capable of sending RTS frames, we
> > should not try to emulate them in SW, as it might make the situation
> > even worse by messing up the NAVs by wrong timing.
> 
> That's not emulation in the software, it's just similar approach as
> with sending fragmented frames - you need (more or less) precise timing
> there as well and many cards still want them enqueued one-by-one. The
> firmware takes care of the precise timing. The same could apply to RTS
> frames (i. e. the firmware recognize them and doesn't send them before
> it has the next frame ready).

And even for a "dumb" device like rt2x00 (no firmware for rt2400pci, rt2500pci or rt2500usb)
it still has rts capabilities. It is just not capable of creating the frame, but
the descriptor has a special field that should be set in case of a rts frame.
So that would suggest that the device will treat the frame a little bit
different than a regular frame.

Ivo